#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <machine/ioctl_bt848.h>
#include <machine/ioctl_meteor.h>
#include <unistd.h>
#include <stdlib.h>

/****************************************************************************/
/*  setsize.c  -  Set the size of the bktr tuner card.                */
/*                                                                          */
/*  COMPILE WITH:  cc -o setsize setsize.c                            */
/****************************************************************************/

#define CXM_MACROBLOCK_WIDTH  16
#define CXM_MACROBLOCK_HEIGHT 16

static void
usage()
{
  printf(
    "Usage: setsize x y\n"
    "default PAL size:	720 576\n"
    "half PAL size:	352 288\n"
    "x and y should be dividable by 16\n"
  );
}

int main( int argc, char *argv[] )
{
  int afc;
  int status;
  int tfd;

  struct bktr_capture_area *cap;

  if (argc!=3) {
    usage ();
    exit (1);
  }

  cap=(struct bktr_capture_area *)calloc(sizeof(struct bktr_capture_area),1);

  cap->x_offset=0;
  cap->y_offset=0;
  cap->x_size=atoi(argv[1]);
  cap->y_size=atoi(argv[2]);

  printf("Setting to %d x %d\n",cap->x_size,cap->y_size);

  afc = -1;
  status = 0;

  tfd = open( "/dev/bktr0", O_RDONLY );
  if ( tfd < 0 ) {
    perror( "open() of /dev/bktr0 failed." );
    exit(1);
  }

  if ( ioctl( tfd, BT848_SCAPAREA, cap ) < 0 ) {
    perror( "ioctl( tfd, BT848_SCAPAREA ) failed." );
    status = 1;
  }

  close ( tfd );
  exit ( status );
}
